<?php
class resizeimage
{
    //图片类型
    var $type;
    //实际宽度
    var $width;
    //实际高度
    var $height;
    //改变后的宽度
    var $resize_width;
    //改变后的高度
    var $resize_height;
    //是否裁图
    var $cut;
    //源图象
    var $srcimg;
    //目标图象地址
    var $dstimg;
    //临时创建的图象
    var $im;
 
    function resizeimage($img, $wid, $hei,$c,$dstpath)
    {
        $this->srcimg = $img;
        $this->resize_width = $wid;
        $this->resize_height = $hei;
        $this->cut = $c;
        //图片的类型
    
$this->type = strtolower(substr(strrchr($this->srcimg,"."),1));
 
        //初始化图象
        $this->initi_img();
        //目标图象地址
        $this -> dst_img($dstpath);
        //--
        $this->width = imagesx($this->im);
        $this->height = imagesy($this->im);
        //生成图象
        $this->newimg();
        ImageDestroy ($this->im);
    }
    function newimg()
    {
        //改变后的图象的比例
        $resize_ratio = ($this->resize_width)/($this->resize_height);
        //实际图象的比例
        $ratio = ($this->width)/($this->height);
        if(($this->cut)=="1")
        //裁图
        {
            if($ratio>=$resize_ratio)
            //高度优先
            {
                $newimg = imagecreatetruecolor($this->resize_width,$this->resize_height);
                imagecopyresampled($newimg, $this->im, 0, 0, 0, 0, $this->resize_width,$this->resize_height, (($this->height)*$resize_ratio), $this->height);
                ImageJpeg ($newimg,$this->dstimg);
            }
            if($ratio<$resize_ratio)
            //宽度优先
            {
                $newimg = imagecreatetruecolor($this->resize_width,$this->resize_height);
                imagecopyresampled($newimg, $this->im, 0, 0, 0, 0, $this->resize_width, $this->resize_height, $this->width, (($this->width)/$resize_ratio));
                ImageJpeg ($newimg,$this->dstimg);
            }
        }
        else
        //不裁图
        {
            if($ratio>=$resize_ratio)
            {
                $newimg = imagecreatetruecolor($this->resize_width,($this->resize_width)/$ratio);
                imagecopyresampled($newimg, $this->im, 0, 0, 0, 0, $this->resize_width, ($this->resize_width)/$ratio, $this->width, $this->height);
                ImageJpeg ($newimg,$this->dstimg);
            }
            if($ratio<$resize_ratio)
            {
                $newimg = imagecreatetruecolor(($this->resize_height)*$ratio,$this->resize_height);
                imagecopyresampled($newimg, $this->im, 0, 0, 0, 0, ($this->resize_height)*$ratio, $this->resize_height, $this->width, $this->height);
                ImageJpeg ($newimg,$this->dstimg);
            }
        }
    }
    //初始化图象
    function initi_img()
    {
        if($this->type=="jpg")
        {
            $this->im = imagecreatefromjpeg($this->srcimg);
        }
        if($this->type=="gif")
        {
            $this->im = imagecreatefromgif($this->srcimg);
        }
        if($this->type=="png")
        {
            $this->im = imagecreatefrompng($this->srcimg);
        }
    }
    //图象目标地址
    function dst_img($dstpath)
    {
        $full_length  = strlen($this->srcimg);
 
        $type_length  = strlen($this->type);
        $name_length  = $full_length-$type_length;
 
 
        $name         = substr($this->srcimg,0,$name_length-1);
        $this->dstimg = $dstpath;
 
 
//echo $this->dstimg;
    }
}
?>
<?php
include '../../conn/connection.php';
/**
 * upload.php
 *
 * Copyright 2013, Moxiecode Systems AB
 * Released under GPL License.
 *
 * License: http://www.plupload.com/license
 * Contributing: http://www.plupload.com/contributing
 */

#!! 注意
#!! 此文件只是个示例，不要用于真正的产品之中。
#!! 不保证代码安全性。

#!! IMPORTANT:
#!! this file is just an example, it doesn't incorporate any security checks and
#!! is not recommended to be used in production environment as it is. Be sure to
#!! revise it and customize to your needs.


// 确保文件没有被缓存（碰巧例如iOS设备）
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
header("Cache-Control: no-store, no-cache, must-revalidate");
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache");
header('Content-type:text/json'); 


// 支持CORS
// header("Access-Control-Allow-Origin: *");
// 如果任何其他的CORS的标题...
if ($_SERVER['REQUEST_METHOD'] == 'OPTIONS') {
    exit; // 完成预检CORS请求
}


if ( !empty($_REQUEST[ 'debug' ]) ) {
    $random = rand(0, intval($_REQUEST[ 'debug' ]) );
    if ( $random === 0 ) {
        header("HTTP/1.0 500 Internal Server Error");
        exit;
    }
}

// header("HTTP/1.0 500 Internal Server Error");
// exit;


// 5分钟的执行时间
@set_time_limit(5 * 60);

// 取消这一假上传时间
// usleep(5000);

// 设置
// $targetDir = ini_get("upload_tmp_dir") . DIRECTORY_SEPARATOR . "plupload";
date_default_timezone_set("PRC");
$targetDir = 'upload_tmp';
$uploadDir = "upload/bgk/".date('Y')."/".date('m');

$cleanupTargetDir = true; // 删除旧的文件
$maxFileAge = 5 * 3600; // 在几秒钟内临时文件的年龄


// 创建目标目录
if (!file_exists($targetDir)) {
    @mkdir($targetDir);
}

// 创建目标目录
if (!is_dir($uploadDir)){@mkdir($uploadDir, 0777, true);}
//if (!file_exists($uploadDir)) {
//    @mkdir($uploadDir);
//}

// 获取一个文件名
$sjwjm=date('YmdHis',time()).mt_rand(1000,9999);//随机文件名
if (isset($_REQUEST["name"])) {
    $fileName = $_REQUEST["name"];
	$rs =  strtolower(trim(substr(strrchr($fileName, "."), 1)));
	$fileName = $sjwjm.'.'.$rs;
	$slfileName=$sjwjm.'-thumbnail.'.$rs;
} elseif (!empty($_FILES)) {
    $fileName = $_FILES["file"]["name"];
	$rs =  strtolower(trim(substr(strrchr($fileName, "."), 1)));
	$fileName = $sjwjm.'.'.$rs;
	$slfileName=$sjwjm.'-thumbnail.'.$rs;
} else {
    $fileName = uniqid("file_");
	$rs =  strtolower(trim(substr(strrchr($fileName, "."), 1)));
	$fileName = $sjwjm.'.'.$rs;
	$slfileName=$sjwjm.'-thumbnail.'.$rs;
}

$filePath = $targetDir . DIRECTORY_SEPARATOR . $fileName;//临时文件名
$uploadPath = $uploadDir . DIRECTORY_SEPARATOR . $fileName;//上传路径文件名
$sluploadPath = $uploadDir . DIRECTORY_SEPARATOR . $slfileName;//缩略图路径文件名

// 块可能被启用
$chunk = isset($_REQUEST["chunk"]) ? intval($_REQUEST["chunk"]) : 0;
$chunks = isset($_REQUEST["chunks"]) ? intval($_REQUEST["chunks"]) : 1;


// 删除旧的临时文件
if ($cleanupTargetDir) {
    if (!is_dir($targetDir) || !$dir = opendir($targetDir)) {
        die('{"jsonrpc" : "2.0", "error" : {"code": 100, "message": "Failed to open temp directory."}, "id" : "id"}');
    }

    while (($file = readdir($dir)) !== false) {
        $tmpfilePath = $targetDir . DIRECTORY_SEPARATOR . $file;

        // 如果临时文件是当前文件，则继续进行下一个
        if ($tmpfilePath == "{$filePath}_{$chunk}.part" || $tmpfilePath == "{$filePath}_{$chunk}.parttmp") {
            continue;
        }

        // 如果它是比最大年龄大的，并不是当前的文件，删除临时文件
        if (preg_match('/\.(part|parttmp)$/', $file) && (@filemtime($tmpfilePath) < time() - $maxFileAge)) {
            @unlink($tmpfilePath);
        }
    }
    closedir($dir);
}


// 打开临时文件
if (!$out = @fopen("{$filePath}_{$chunk}.parttmp", "wb")) {
    die('{"jsonrpc" : "2.0", "error" : {"code": 102, "message": "Failed to open output stream."}, "id" : "id"}');
}

if (!empty($_FILES)) {
    if ($_FILES["file"]["error"] || !is_uploaded_file($_FILES["file"]["tmp_name"])) {
        die('{"jsonrpc" : "2.0", "error" : {"code": 103, "message": "Failed to move uploaded file."}, "id" : "id"}');
    }

    //读取二进制输入流并将其追加到临时文件中
    if (!$in = @fopen($_FILES["file"]["tmp_name"], "rb")) {
        die('{"jsonrpc" : "2.0", "error" : {"code": 101, "message": "Failed to open input stream."}, "id" : "id"}');
    }
} else {
    if (!$in = @fopen("php://input", "rb")) {
        die('{"jsonrpc" : "2.0", "error" : {"code": 101, "message": "Failed to open input stream."}, "id" : "id"}');
    }
}

while ($buff = fread($in, 4096)) {
    fwrite($out, $buff);
}

@fclose($out);
@fclose($in);

rename("{$filePath}_{$chunk}.parttmp", "{$filePath}_{$chunk}.part");

$index = 0;
$done = true;
for( $index = 0; $index < $chunks; $index++ ) {
    if ( !file_exists("{$filePath}_{$index}.part") ) {
        $done = false;
        break;
    }
}
if ( $done ) {
    if (!$out = @fopen($uploadPath, "wb")) {
        die('{"jsonrpc" : "2.0", "error" : {"code": 102, "message": "Failed to open output stream."}, "id" : "id"}');
    }

    if ( flock($out, LOCK_EX) ) {
        for( $index = 0; $index < $chunks; $index++ ) {
            if (!$in = @fopen("{$filePath}_{$index}.part", "rb")) {
                break;
            }

            while ($buff = fread($in, 4096)) {
                fwrite($out, $buff);
            }

            @fclose($in);
            @unlink("{$filePath}_{$index}.part");
        }

        flock($out, LOCK_UN);
    }
    @fclose($out);
}
// 生成缩略图
$resizeimage = new resizeimage($uploadPath, "100", "100", "0",$sluploadPath);
//就只用上面的一句话,就能生成缩略图,其中,源文件和缩略图地址可以相同,200,100分别代表宽和高


// 返回成功RPC响应
//die('{"jsonrpc" : "2.0", "result" : null, "id" : "id","uploadPath":"uploadPath"}');
$dat['imgurl'] = $uploadPath;
$dat2['slimgurl'] = $sluploadPath;
$fhdate=array_merge($dat,$dat2);
echo json_encode($fhdate);